"use strict";

// この chai-plugin は https://github.com/krampstudio/chai-xml をブラウザで動作するように書き換えたものです
function chaiXmlPlugin(chai, utils) {
  var x2j = function x2j(xml) {
    var doc = new DOMParser().parseFromString(xml, "application/xml");

    var dig = function dig(e) {
      var x = {
        name: e.tagName,
        attr: {},
        children: []
      };

      for (var i = 0; i < e.attributes.length; i++) {
        x.attr[e.attributes[i].name] = e.attributes[i].value;
      }

      for (var f = e.firstChild; f; f = f.nextSibling) {
        if (f.nodeType === 1) x.children.push(dig(f));else if (f.nodeType === 3 && !f.nodeValue.match(/^\s*$/)) x.children.push(f.nodeValue);
      }

      if (Object.keys(x.attr).length === 0) delete x.attr;
      if (x.children.length === 0) delete x.children;
      return x;
    };

    return dig(doc.documentElement);
  };

  var flag = utils.flag;
  var Assertion = chai.Assertion;
  Assertion.addProperty('xml', function () {
    new Assertion(this._obj).to.be.a('string');
    flag(this, 'xml', true);
  });

  var compareXml = function compareXml(_super) {
    return function assertEqual(value) {
      var negate;

      if (flag(this, 'xml')) {
        negate = flag(this, 'negate');
        var actual = x2j(this._obj);
        var expected = x2j(value);

        if (negate) {
          new Assertion(actual).to.not.deep.equals(expected);
        } else {
          new Assertion(actual).to.deep.equals(expected);
        }
      } else {
        _super.apply(this, arguments);
      }
    };
  };

  Assertion.overwriteMethod('equal', compareXml);
  Assertion.overwriteMethod('equals', compareXml);
  Assertion.overwriteMethod('eq', compareXml);
}

;