"use strict";

if (global) {
  var expect = require('chai').expect;

  var IMILib2017Common = require('../lib/imi-lib-2017-common');

  var fs = require("fs");

  var dir = __dirname + "/test-vocabulary/";
  var xsd = new IMILib2017Common.Vocabulary(fs.readFileSync(dir + "xsd.imiv", "UTF-8").replace(/^\uFEFF/, ""));
}

describe('IMILib2017Common.Vocabulary', function () {
  describe('語彙の読み込み機能', function () {
    it('コア語彙2.4.1が読み込めること', function () {
      //var v = new IMILib2017Common.Vocabulary(fs.readFileSync(dir + "xsd.imiv.txt", "UTF-8").replace(/^\uFEFF/, ""), xsd);
      expect(function () {
        var v = new IMILib2017Common.Vocabulary(fs.readFileSync(dir + "imicore241.imiv", "UTF-8").replace(/^\uFEFF/, ""), xsd);
      }).not.to.throw(); //expect(v.validate(IMIToolsCore.Vocabulary.LEVEL_WARN)).to.be.empty;
    });
    it('コア語彙2.4.2が読み込めること', function () {
      //var v = new IMILib2017Common.Vocabulary(fs.readFileSync(dir + "xsd.imiv.txt", "UTF-8").replace(/^\uFEFF/, ""), xsd);
      expect(function () {
        var v = new IMILib2017Common.Vocabulary(fs.readFileSync(dir + "imicore242.imiv", "UTF-8").replace(/^\uFEFF/, ""), xsd);
      }).not.to.throw(); //expect(v.validate(IMIToolsCore.Vocabulary.LEVEL_WARN)).to.be.empty;
    });
  });
});